<?php

namespace Feedbii\DataCollector;


/**
 * Class Customer
 * @package Feedbii\DataCollector
 */
class Customer extends AbstractDataCollector implements DataCollectorInterface
{

    /**
     * @return array
     */
    public function getCustomer()
    {
        $sql='
        SELECT
         c.client_id
        , DATE_FORMAT(c.client_date_ajout,"%Y-%m-%d") as date
        , IF(c.client_newsletter_id = 1, "1", "0") as newsletter
        , c.client_email
        , a.adresse_ville as city
        , a.adresse_cp as postcode
        , p.pays_iso_code_2 as country
         FROM client c
         LEFT JOIN adresse a ON (a.client_id = c.client_id AND a.adresse_default = 1)
         LEFT JOIN pays p ON (p.pays_id = a.pays_id)
         WHERE 1

        AND DATE(c.client_date_ajout) >= "'.$this->getDateFrom()->format('Y-m-d').'"
        AND DATE(c.client_date_ajout) <= "'.$this->getDateTo()->format('Y-m-d').'"
        GROUP BY c.client_id
        ';
        $this->db->getAll($sql);
        $result = $this->db->record;

        if (!$result){
            echo mysqli_error($this->db);
        }

        $arrClient = array();

        foreach($result as $row) {
            array_push($arrClient, $row);
        }

        foreach ($arrClient as $k => $client){
            $arrClient[$k]['client_id'] = (int)$arrClient[$k]['client_id'];
            $arrClient[$k]['newsletter'] = (int)$arrClient[$k]['newsletter'];
            $arrClient[$k]['country'] = strtoupper($arrClient[$k]['country']);
        }
        return $arrClient;
    }

}