<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 05/05/2017
 * Time: 11:09
 */

namespace Feedbii\Router;

/**
 * Class Route
 */
class Route {

    /**
     * @var string
     */
    private $path;
    /**
     * @var
     */
    private $callable;
    /**
     * @var array
     */
    private $matches = [];
    /**
     * @var array
     */
    private $params = [];

    /**
     * Route constructor.
     *
     * @param $path
     * @param $callable
     */
    public function __construct($path, $callable){
        $this->path = trim($path, '/');  // On retire les / inutils
        $this->callable = $callable;
    }

    /**
     * @param $url
     *
     * @return bool
     */
    public function match($url){
        $url = trim($url, '/');
        $path = preg_replace('#:([\w]+)#', '([^/]+)', $this->path);
        $regex = "#^$path$#i";
        if(!preg_match($regex, $url, $matches)){
            return false;
        }
        array_shift($matches);
        $this->matches = $matches;
        return true;
    }

    public function call(){
        $data = call_user_func_array($this->callable, $this->matches);
        if (empty($data)){
            throw  new \Exception('NO DATA');
        }
        return $data;
    }

}